using System;
using System.Collections.Generic;
using System.Text;

namespace ShoreSide.Core
{
    public class Body
    {
        public enum Joints
        {
            ShoulderYaw = 0,
            ShoulderPitch = 1,
            Elbow = 2
        }

        private Leg[] legs = new Leg[6];

        public Leg[] Legs
        {
            get
            {
                return legs;
            }
        }

        private Body()
        {
        }

        public static Body FromReadings()
        {
            Body b = new Body();
            for (int i = 0; i < 6; i++)
                b.legs[i] = Leg.FromReadings(i);

            return b;
        }

        public static int ServoMap(int LegIndex, Joints JointIndex)
        {
            switch (LegIndex)
            {
                case 0:
                    return 3 + (int)JointIndex;
                case 1:
                    return 0 + (int)JointIndex;
                case 2:
                    return 9 + (int)JointIndex;
                case 3:
                    return 6 + (int)JointIndex;
                case 4:
                    return 15 + (int)JointIndex;
                case 5:
                    return 12 + (int)JointIndex;
            }
            return -1;
        }
    }
}
