using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ShoreSide.Core;

namespace ShoreSide.UI
{
    public partial class Feet : SSForm
    {
        private bool InUpdate = false;
        public Feet()
        {
            InitializeComponent();
        }

        private void TimerUpdate()
        {
            chkLFEN.Checked = PCTControllers.LandReflexes[0].Enabled;
            chkLMEN.Checked = PCTControllers.LandReflexes[1].Enabled;
            chkLREN.Checked = PCTControllers.LandReflexes[2].Enabled;
            chkRREN.Checked = PCTControllers.LandReflexes[3].Enabled;
            chkRMEN.Checked = PCTControllers.LandReflexes[4].Enabled;
            chkRFEN.Checked = PCTControllers.LandReflexes[5].Enabled;

            chkLF.Checked = PCTControllers.LandReflexes[0].Perception() == 1;
            chkLM.Checked = PCTControllers.LandReflexes[1].Perception() == 1;
            chkLR.Checked = PCTControllers.LandReflexes[2].Perception() == 1;
            chkRR.Checked = PCTControllers.LandReflexes[3].Perception() == 1;
            chkRM.Checked = PCTControllers.LandReflexes[4].Perception() == 1;
            chkRF.Checked = PCTControllers.LandReflexes[5].Perception() == 1;

            meter1.Value = PCTControllers.LandReflexes[0].RawValue;
            meter2.Value = PCTControllers.LandReflexes[1].RawValue;
            meter3.Value = PCTControllers.LandReflexes[2].RawValue;
            meter4.Value = PCTControllers.LandReflexes[3].RawValue;
            meter5.Value = PCTControllers.LandReflexes[4].RawValue;
            meter6.Value = PCTControllers.LandReflexes[5].RawValue;

            meter1.ThresholdValue = PCTControllers.LandReflexes[0].ContactThreshold;
            meter2.ThresholdValue = PCTControllers.LandReflexes[1].ContactThreshold;
            meter3.ThresholdValue = PCTControllers.LandReflexes[2].ContactThreshold;
            meter4.ThresholdValue = PCTControllers.LandReflexes[3].ContactThreshold;
            meter5.ThresholdValue = PCTControllers.LandReflexes[4].ContactThreshold;
            meter6.ThresholdValue = PCTControllers.LandReflexes[5].ContactThreshold;
        }
        private void tmr_Tick(object sender, EventArgs e)
        {
            TimerUpdate();
        }

        private void chkLFEN_CheckedChanged(object sender, EventArgs e)
        {
            UpdateEnable();
        }

        private void chkRFEN_CheckedChanged(object sender, EventArgs e)
        {
            UpdateEnable();
        }

        private void chkLMEN_CheckedChanged(object sender, EventArgs e)
        {
            UpdateEnable();
        }

        private void chkRMEN_CheckedChanged(object sender, EventArgs e)
        {
            UpdateEnable();
        }

        private void chkLREN_CheckedChanged(object sender, EventArgs e)
        {
            UpdateEnable();
        }

        private void chkRREN_CheckedChanged(object sender, EventArgs e)
        {
            UpdateEnable();
        }

        private void UpdateEnable()
        {
            if (InUpdate) return;
            PCTControllers.LandReflexes[0].Enabled = chkLFEN.Checked;
            PCTControllers.LandReflexes[1].Enabled = chkLMEN.Checked;
            PCTControllers.LandReflexes[2].Enabled = chkLREN.Checked;
            PCTControllers.LandReflexes[3].Enabled = chkRREN.Checked;
            PCTControllers.LandReflexes[4].Enabled = chkRMEN.Checked;
            PCTControllers.LandReflexes[5].Enabled = chkRFEN.Checked;
        }

        private void btnZeroAll_Click(object sender, EventArgs e)
        {
            foreach (LandReflex lr in PCTControllers.LandReflexes)
                lr.ContactThreshold = lr.RawValue + 40;
        }

        private void btnEnable_Click(object sender, EventArgs e)
        {
            foreach (LandReflex lr in PCTControllers.LandReflexes)
                lr.Enabled = true;
            InUpdate = true;
            TimerUpdate();
            Application.DoEvents();
            InUpdate = false;
        }

        private void btnDisable_Click(object sender, EventArgs e)
        {
            foreach (LandReflex lr in PCTControllers.LandReflexes)
                lr.Enabled = false;
            InUpdate = true;
            TimerUpdate();
            Application.DoEvents();
            InUpdate = false;
        }
    }
}