using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.IO;
using ShoreSide.Core;

namespace ShoreSide.UI
{
    public partial class FirmwareUpdate : SSForm
    {
        public FirmwareUpdate()
        {
            InitializeComponent();
            fileDialog.FileName = Controller.Settings.HexFilename;
            textFilename.Text = fileDialog.FileName;
        }

        private void LoadHexFile()
        {
            string filename = textFilename.Text;

            BootLoader.Clear();
            Controller.Trace("BOOT: Parsing hex file");
            if (BootLoader.ParseHexFile(filename))
            {
                BootLoader.PrepareHex();
                Controller.Trace("BOOT: Parse Success");
            }
            else
                Controller.Trace("BOOT: Parse Failed");
        }

        private void buttonParse_Click(object sender, EventArgs e)
        {
            if (System.IO.File.Exists(textFilename.Text))
                LoadHexFile();
        }

        private void buttonUpdate_Click(object sender, EventArgs e)
        {
            Controller.BootLoadPending = true;
            //BootLoader.ReadyToLoad = true;
        }

        private void buttonBrowse_Click_1(object sender, EventArgs e)
        {
            if (fileDialog.ShowDialog(this) == DialogResult.OK)
            {
                textFilename.Text = fileDialog.FileName;
                Controller.Settings.HexFilename = fileDialog.FileName;


                Controller.Settings.Save();

                LoadHexFile();
            }
        }

        private void buttonFresh_Click(object sender, EventArgs e)
        {
            BootLoader.ReadyToLoad = true;
        }
    }
}