using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ShoreSide.Core;

namespace ShoreSide.UI
{
    public partial class PCTPerceptions : SSForm
    {
        public PCTPerceptions()
        {
            InitializeComponent();
            pctWidget1.Controller = PCTControllers.Height;
            pctWidget2.Controller = PCTControllers.Forward;
            pctWidget3.Controller = PCTControllers.Right;
            pctWidget4.Controller = PCTControllers.Heading;
            pctWidget5.Controller = PCTControllers.Pitch;
            pctWidget6.Controller = PCTControllers.Roll;
            pctWidget7.Controller = PCTControllers.Radius;
            pctWidget8.Controller = PCTControllers.StepHeight;
            numericFrameRate.Value = (decimal)timerCycle.Interval;
        }

        protected override void OnClosed(EventArgs e)
        {
            base.OnClosed(e);
            PCTLinker.ZeroServos();
        }

        private void timerCycle_Tick(object sender, EventArgs e)
        {
            pctWidget1.Cycle();
            pctWidget2.Cycle();
            pctWidget3.Cycle();
            pctWidget4.Cycle();
            pctWidget5.Cycle();
            pctWidget6.Cycle();
            pctWidget7.Cycle();

            PCTControllers.Cycle();
        }

        private void numericFrameRate_ValueChanged(object sender, EventArgs e)
        {
            timerCycle.Interval = (int)numericFrameRate.Value;
        }

        private void numericFootSpeed_ValueChanged(object sender, EventArgs e)
        {
            foreach (LandReflex lr in PCTControllers.LandReflexes)
                lr.LandingSpeed = (double)numericFootSpeed.Value;
        }
    }
}