using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using ShoreSide.Core;

namespace ShoreSide.UI
{
    public partial class Test : SSForm
    {
        public Test()
        {
            InitializeComponent();
            histogram1.AddHistogram(new SampleHistogram(f1), Color.Red, 0, 255);
            histogram1.AddHistogram(new SampleHistogram(f2), Color.Red, 0, 255);
            histogram1.AddHistogram(new SampleHistogram(f3), Color.Red, 0, 255);
            histogram1.AddHistogram(new SampleHistogram(f4), Color.Red, 0, 255);
            histogram1.AddHistogram(new SampleHistogram(f5), Color.Red, 0, 255);
            histogram1.AddHistogram(new SampleHistogram(f6), Color.Red, 0, 255);
            
            histogram1.UpdateDelay = TimeSpan.FromMilliseconds(50);
        }

        private double f1()
        {
            return (double)Perceptions.FootSensors[0];
        }

        private double f2()
        {
            return (double)Perceptions.FootSensors[1];
        }

        private double f3()
        {
            return (double)Perceptions.FootSensors[2];
        }

        private double f4()
        {
            return (double)Perceptions.FootSensors[3];
        }

        private double f5()
        {
            return (double)Perceptions.FootSensors[4];
        }

        private double f6()
        {
            return (double)Perceptions.FootSensors[5];
        }

        private double Current()
        {
            return (double)Controller.LastCyclePacket.Current[1];
        }

        private double Position()
        {
            return (double)Controller.LastCyclePacket.Positions[1];
        }

        private double AdjustedPosition()
        {
            return (double)Controller.LastCyclePacket.Positions[1] + (double)numericUpDown1.Value * Current();
        }

        private void numericUpDown2_ValueChanged(object sender, EventArgs e)
        {
            meter1.Value = (double)numericUpDown2.Value;
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            meter1.ThresholdValue = (double)numericUpDown3.Value;
        }
    }
}